Subject: bug#52507: [PATCH] Option for vc-delete-file to keep file on disk

From: Dmitry Gutov <[email-masked]>
Date: Mon, 27 Dec 2021 02:03:46 +0200

On 26.12.2021 20:03, Ashwin Kafle wrote:
> Dmitry Gutov <[email-masked]> writes:
> 
>> On 26.12.2021 19:12, Ashwin Kafle wrote:
>>>> All right.
>>>>
>>>> Well, it seems like it will add more cognitive load in the "common"
>>>> scenario -- where you end up deleting the file you said you want to
>>>> delete.
>>>>
>>>> And it will be a breaking change in the existing behavior/UI.
>>> If you delete from disk it behaves exactly like how it's doing right
>>> now.  The only difference should be when you delete and immediately
>>> restore from backup and in that case, only vc-dir shows one extra file.
>>> I don't think it brakes any existing behavior.
>>
>> But the file would stay around, right? That would be different.
> 
> Only if you give vc-delete-file a prefix argument, otherwise it'll be
> exactly the same.  It will delete even if we use git rm --cached (because
> it is checked later if the file exists anymore or not)

OK, that seems to make sense. But how would we convey to the user that 
that "removed" (followed by "unregistered") refers to the staging area?

Patch which would implement this in VC-Dir/Git is welcome.

And the next step would be to ensure that such deletions (which keep the 
file on disk) can be committed by vc-next-action.